#include <math.h>

double getRBConEnergy (
  double young,
  double shear,
  double radw,
  double radh,
  double hL0,
  double *undefMatTanRB,
  double *undefMatNorRB,
  double *undefRefTanRO,
  double *undefRefNorRO,
  double rtx,
  double *rotationAnglesRB,
  double *x1,
  double *x2,
  double thetaxRaw,
  double Sig)
{
  double t103;
  double t104;
  double t107;
  double t109;
  double t110;
  double t112;
  double t115;
  double t119;
  double t12;
  double t122;
  double t124;
  double t126;
  double t128;
  double t13;
  double t131;
  double t133;
  double t134;
  double t135;
  double t137;
  double t139;
  double t141;
  double t147;
  double t151;
  double t157;
  double t161;
  double t167;
  double t17;
  double t173;
  double t174;
  double t176;
  double t178;
  double t18;
  double t183;
  double t190;
  double t195;
  double t204;
  double t207;
  double t213;
  double t218;
  double t22;
  double t228;
  double t23;
  double t234;
  double t244;
  double t25;
  double t251;
  double t253;
  double t26;
  double t263;
  double t265;
  double t266;
  double t267;
  double t268;
  double t27;
  double t270;
  double t280;
  double t283;
  double t29;
  double t290;
  double t296;
  double t3;
  double t301;
  double t309;
  double t31;
  double t318;
  double t327;
  double t33;
  double t35;
  double t37;
  double t39;
  double t4;
  double t40;
  double t41;
  double t47;
  double t48;
  double t54;
  double t55;
  double t63;
  double t68;
  double t70;
  double t73;
  double t78;
  double t8;
  double t81;
  double t82;
  double t83;
  double t84;
  double t85;
  double t86;
  double t87;
  double t88;
  double t90;
  double t91;
  double t92;
  double t93;
  double t95;
  double t96;
  double t98;
  double t99;
  t3 = radw * radw;
  t4 = radh * radh;
  t8 = thetaxRaw * Sig;
  t12 = x2[0] - 0.1e1 * x1[0];
  t13 = t12 * t12;
  t17 = x2[1] - 0.1e1 * x1[1];
  t18 = t17 * t17;
  t22 = x2[2] - 0.1e1 * x1[2];
  t23 = t22 * t22;
  t25 = sqrt(t13 + t18 + t23);
  t26 = 0.1e1 / t25;
  t27 = t26 * t17;
  t29 = undefRefTanRO[0] * t26;
  t31 = 0.1e1 * t29 * t12;
  t33 = undefRefTanRO[1] * t26;
  t35 = 0.1e1 * t33 * t17;
  t37 = undefRefTanRO[2] * t26;
  t39 = 0.1e1 * t37 * t22;
  t40 = t31 + t35 + t39;
  t41 = undefRefNorRO[2];
  t47 = 0.1e1 * t33 * t22 - 0.1e1 * t37 * t17;
  t48 = undefRefNorRO[1];
  t54 = 0.1e1 * t37 * t12 - 0.1e1 * t29 * t22;
  t55 = undefRefNorRO[0];
  t63 = 0.1e1 * t29 * t17 - 0.1e1 * t33 * t12;
  t68 = (t47 * t55 + t54 * t48 + t63 * t41) / (0.1e1 + t31 + t35 + t39);
  t70 = t40 * t41 + t47 * t48 - t54 * t55 + t68 * t63;
  t73 = t26 * t22;
  t78 = t40 * t48 + t63 * t55 - t47 * t41 + t68 * t54;
  t81 = 0.1e1 * t27 * t70 - 0.1e1 * t73 * t78;
  t82 = cos(rtx);
  t83 = rotationAnglesRB[2];
  t84 = cos(t83);
  t85 = rotationAnglesRB[1];
  t86 = cos(t85);
  t87 = t84 * t86;
  t88 = undefMatTanRB[0];
  t90 = sin(t85);
  t91 = t84 * t90;
  t92 = rotationAnglesRB[0];
  t93 = sin(t92);
  t95 = sin(t83);
  t96 = cos(t92);
  t98 = t91 * t93 - t95 * t96;
  t99 = undefMatTanRB[1];
  t103 = t91 * t96 + t95 * t93;
  t104 = undefMatTanRB[2];
  t107 = (t87 * t88 + t98 * t99 + t103 * t104) * t26;
  t109 = 0.1e1 * t107 * t12;
  t110 = t95 * t86;
  t112 = t95 * t90;
  t115 = t112 * t93 + t84 * t96;
  t119 = t112 * t96 - t84 * t93;
  t122 = (t110 * t88 + t115 * t99 + t119 * t104) * t26;
  t124 = 0.1e1 * t122 * t17;
  t126 = t86 * t93;
  t128 = t86 * t96;
  t131 = (-t90 * t88 + t126 * t99 + t128 * t104) * t26;
  t133 = 0.1e1 * t131 * t22;
  t134 = t109 + t124 + t133;
  t135 = undefMatNorRB[0];
  t137 = undefMatNorRB[1];
  t139 = undefMatNorRB[2];
  t141 = t87 * t135 + t98 * t137 + t103 * t139;
  t147 = 0.1e1 * t131 * t12 - 0.1e1 * t107 * t22;
  t151 = -t90 * t135 + t126 * t137 + t128 * t139;
  t157 = 0.1e1 * t107 * t17 - 0.1e1 * t122 * t12;
  t161 = t110 * t135 + t115 * t137 + t119 * t139;
  t167 = 0.1e1 * t122 * t22 - 0.1e1 * t131 * t17;
  t173 = 0.1e1 / (0.1e1 + t109 + t124 + t133);
  t174 = (t167 * t141 + t147 * t161 + t157 * t151) * t173;
  t176 = t134 * t141 + t147 * t151 - t157 * t161 + t174 * t167;
  t178 = sin(rtx);
  t183 = t134 * t151 + t167 * t161 - t147 * t141 + t174 * t157;
  t190 = t134 * t161 + t157 * t141 - t167 * t151 + t174 * t147;
  t195 = t26 * t12;
  t204 = (0.1e1 * t195 * t176 + 0.1e1 * t27 * t190 + 0.1e1 * t73 * t183) * (0.1e1 - t82);
  t207 = t82 * t176 + t178 * (0.1e1 * t27 * t183 - 0.1e1 * t73 * t190) + 0.1e1 * t204 * t195;
  t213 = t40 * t55 + t54 * t41 - t63 * t48 + t68 * t47;
  t218 = 0.1e1 * t73 * t213 - 0.1e1 * t195 * t70;
  t228 = t82 * t190 + t178 * (0.1e1 * t73 * t176 - 0.1e1 * t195 * t183) + 0.1e1 * t204 * t27;
  t234 = 0.1e1 * t195 * t78 - 0.1e1 * t27 * t213;
  t244 = t82 * t183 + t178 * (0.1e1 * t195 * t190 - 0.1e1 * t27 * t176) + 0.1e1 * t204 * t73;
  t251 = atan2(t81 * t207 + t218 * t228 + t234 * t244, t213 * t207 + t78 * t228 + t70 * t244);
  t253 = pow(t8 + rtx - t251, 0.2e1);
  t263 = pow(0.5e0 * radw + 0.5e0 * radh, 0.2e1);
  t265 = hL0 * hL0;
  t266 = 0.1e1 / t265;
  t267 = t173 * t167;
  t268 = cos(t8);
  t270 = sin(t8);
  t280 = (0.1e1 * t195 * t213 + 0.1e1 * t27 * t78 + 0.1e1 * t73 * t70) * (0.1e1 - t268);
  t283 = t268 * t70 + t270 * t234 + 0.1e1 * t280 * t73;
  t290 = t268 * t78 + t270 * t218 + 0.1e1 * t280 * t27;
  t296 = t173 * t147;
  t301 = t268 * t213 + t270 * t81 + 0.1e1 * t280 * t195;
  t309 = t173 * t157;
  t318 = pow(0.2e1 * t267 * (0.1e1 * t27 * t283 - 0.1e1 * t73 * t290) + 0.2e1 * t296 * (0.1e1 * t73 * t301 - 0.1e1 * t195 * t283) + 0.2e1 * t309 * (0.1e1 * t195 * t290 - 0.1e1 * t27 * t301), 0.2e1);
  t327 = pow(-0.2e1 * t267 * t301 - 0.2e1 * t296 * t290 - 0.2e1 * t309 * t283, 0.2e1);
  return(0.1250000000e0 * shear * radw * radh * M_PI * (t3 + t4) / hL0 * t253 + 0.1250000000e0 * young * radw * radh * M_PI * t263 * hL0 * (t266 * t318 + t266 * t327));
}
